using OSMDatastructure;
using OSMDatastructure.Graph;

namespace Server;

public class Server
{
    
    public static void Main(string[] args)
    {
        ConsoleWriter newConsole = new ConsoleWriter();
        Console.SetOut(newConsole);
        Console.SetError(newConsole);
       
        //RegionConverter.ConvertXMLToRegions("D:/stuttgart-regbez-latest.osm", "D:/stuttgart-regbez-latest");
        RegionConverter.ConvertXMLToRegions("D:/map.osm", "D:/map");
        Console.WriteLine("Loaded");
        RegionLoader rl = new RegionLoader("D:/map");
        Region r = rl.GetRegion(13870001898000);
        Console.WriteLine(r.nodes.First());
        Console.WriteLine(r.ways.First());
        Console.WriteLine(rl.GetTagsForWay(13870001898000, 5897420)!.Last());
        Console.WriteLine("Region loaded");

        /*
        Coordinates start = new Coordinates(48.243351f, 11.640417f);
        Coordinates finish = new Coordinates(48.25239f, 11.53272f);
        OsmNode[] path = Pathfinder.CustomAStar("/home/glax/Downloads/oberbayern-latest", start, finish, OsmEdge.speedType.car).ToArray();
        Console.WriteLine("{0}\n", path[0].ToString());
        for (int i = 0; i < path.Length - 1; i++)
        {
            OsmNode n1 = path[i];
            OsmNode n2 = path[i + 1];
            OsmEdge? e = n1.GetEdgeToNode(n2);
            if(e != null)
                Console.WriteLine("{0}\n{1}", e.ToString(), n2.ToString());
            else
                Console.WriteLine("NO EDGE\n{0}", n2.ToString());
        }
        Console.WriteLine();*/
    }
}